Index: /java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 90)
@@ -62,5 +62,5 @@
 		iconName = TreeCellRenderer.findIconName(name, path.getTextual());
 		tooltip = "?";
-		path.getInstance().invokeLater(new RunAt<Instance>() {
+		path.getInstance().dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -85,5 +85,5 @@
 		assert p.getInstance().isActive();
 		if (Logging.log(log, "fetch", TreeNode.this, e)) {
-			frame.invokeLater(new RunAt<Frame>() {
+			frame.dispatch(new RunAt<Frame>() {
 				@Override
 				public void run() {
@@ -95,5 +95,5 @@
 		}
 		updateChildren(p);
-		frame.invokeLater(new RunAt<Frame>() {
+		frame.dispatch(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -107,5 +107,5 @@
 		assert !frame.isActive();
 		/** TODO those two actions could be merged into single closure */
-		frame.invokeLater(new RunAt<Frame>() {
+		frame.dispatch(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -152,5 +152,5 @@
 		/**If some child were found, update in frame context.*/
 		if (childrenPaths.size() > 0) {
-			frame.invokeLater(new RunAt<Frame>() {
+			frame.dispatch(new RunAt<Frame>() {
 				@Override
 				public void run() {
@@ -189,5 +189,5 @@
 		final Path p = path;
 
-		p.getInstance().invokeLater(new RunAt<Instance>() {
+		p.getInstance().dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -249,5 +249,5 @@
 		final String name = (nameParam != null ? access.get(nameParam, String.class) : path.getTop().getParam().getId());
 
-		frame.invokeLater(new RunAt<Frame>() {
+		frame.dispatch(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -306,5 +306,5 @@
 		assert p.isResolved();
 		panel.setCurrentTreeNode(this);
-		p.getInstance().invokeLater(new RunAt<Instance>() {
+		p.getInstance().dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -312,5 +312,5 @@
 				panel.pullValuesFromLocalToUser(access);
 
-				frame.invokeLater(new RunAt<Frame>() {
+				frame.dispatch(new RunAt<Frame>() {
 					@Override
 					public void run() {
@@ -344,5 +344,5 @@
 		final Path p = path;
 		log.debug("preparing panel: " + p);
-		p.getInstance().invokeLater(new RunAt<Instance>() {
+		p.getInstance().dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -350,5 +350,5 @@
 				final CompositeParam param = p.getTop().getParam();
 				final FramsClass framsClass = p.getInstance().getInfoFromCache(param.getContainedTypeName());
-				frame.invokeLater(new RunAt<Frame>() {
+				frame.dispatch(new RunAt<Frame>() {
 					@Override
 					public void run() {
@@ -503,5 +503,5 @@
 		final Map<ValueControl, Object> changes = localChanges;
 		localChanges = null;
-		instanceAtFrame.getInstance().invokeLater(new RunAt<Instance>() {
+		instanceAtFrame.getInstance().dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -517,5 +517,5 @@
 							}
 							log.debug("applied changes for: " + p);
-							frame.invokeLater(new RunAt<Frame>() {
+							frame.dispatch(new RunAt<Frame>() {
 								@Override
 								public void run() {
Index: /java/main/src/main/java/com/framsticks/gui/configuration/UserFavourite.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/configuration/UserFavourite.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/gui/configuration/UserFavourite.java	(revision 90)
@@ -0,0 +1,68 @@
+package com.framsticks.gui.configuration;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+/**
+ * Class stores information about user favourite node or field.
+ */
+@FramsClassAnnotation
+public class UserFavourite {
+
+	/**
+	 * Name of node/field.
+	 */
+	protected String name;
+
+	/**
+	 * Path to node/field.
+	 */
+	protected String path;
+
+	/**
+	 * Field name - property getId or group name if node is group;
+	 */
+	protected String fieldId;
+
+	public UserFavourite() {
+	}
+
+	@ParamAnnotation
+	public String getPath() {
+		return path;
+	}
+
+	/**
+	 * @param path the path to set
+	 */
+	@ParamAnnotation
+	public void setPath(String path) {
+		this.path = path;
+	}
+
+	/**
+	 * @param fieldId the fieldId to set
+	 */
+	@ParamAnnotation
+	public void setFieldId(String fieldId) {
+		this.fieldId = fieldId;
+	}
+
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	@ParamAnnotation
+	public String getFieldId() {
+		return fieldId;
+	}
+}
Index: /java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 90)
@@ -22,7 +22,9 @@
 	protected Frame frame;
 	protected final Param param;
+	protected ControlOwner owner;
 
 	public Control(Param param) {
 		this.param = param;
+		setName(param.getId());
 
 		this.setEnabled(!param.hasFlag(Flags.READONLY));
@@ -38,4 +40,8 @@
 	}
 
+	public void setOwner(ControlOwner owner) {
+		this.owner = owner;
+	}
+
 	protected void addAsOnlyChild(JComponent component) {
 		this.setLayout(new BorderLayout());
Index: /java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 90)
@@ -0,0 +1,12 @@
+package com.framsticks.gui.controls;
+
+import javax.swing.JPanel;
+
+import com.framsticks.gui.TreeNode;
+
+public interface ControlOwner {
+
+	public JPanel getPanel();
+	public TreeNode getCurrentTreeNode();
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 90)
@@ -1,22 +1,35 @@
 package com.framsticks.gui.controls;
 
+import com.framsticks.core.Instance;
+import com.framsticks.core.Path;
 import com.framsticks.gui.Gui;
+import com.framsticks.gui.TreeNode;
 import com.framsticks.params.Param;
+import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.Logging;
+import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.RunAt;
 
 import javax.swing.*;
 import javax.swing.border.BevelBorder;
+
+import org.apache.log4j.Logger;
+
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
 import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
 import java.util.Map;
 
 @SuppressWarnings("serial")
-public class ProcedureControl extends Control {
-	// private static final Logger log = Logger.getLogger(Control.class.getName());
+public class ProcedureControl extends Control implements ControlOwner {
+
+	private static final Logger log = Logger.getLogger(ProcedureControl.class);
 
 	protected final JButton procedureButton;
 
-	final protected Map<Param, Control> components = new HashMap<Param, Control>();
+	final protected Map<ValueParam, ValueControl> components = new HashMap<>();
 
 	public ProcedureControl(ProcedureParam procedureParam) {
@@ -24,8 +37,9 @@
 
 		procedureButton = new JButton("Call");
+		procedureButton.setName("call");
 
 		this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
 
-		Gui.fillWithControls(this, procedureParam.getArgumentsType(), components);
+		Gui.fillWithControls(this, procedureParam.getArgumentsType(), components, ValueControl.class);
 
 		if (components.size() != procedureParam.getArgumentsType().size()) {
@@ -39,22 +53,26 @@
 			@Override
 			public void actionPerformed(ActionEvent e) {
+				TreeNode treeNode = owner.getCurrentTreeNode();
+				assert treeNode != null;
 
-/*
-				Node node = panel.getCurrentNode();
-				if (argumentWindow != null) {
-					argumentWindow.askForArguments();
-					return;
+				log.debug("calling " + getParam() + " on " + treeNode);
+				final Path path = treeNode.getInstancePath();
+
+				final List<Object> arguments = new LinkedList<Object>();
+				for (Param arg : getParam().getArgumentsType()) {
+					arguments.add(((ValueControl) components.get(arg)).getCurrentValue());
 				}
-				node.getConnection().send(new CallQuery().setMethod(param.getId()).setPath(node.getPath()).setCallback(new QueryCallback() {
+
+				path.getInstance().dispatch(new RunAt<Instance>() {
 					@Override
-					public void call(boolean ok, String comment, SourceInterface content) {
-						if (!ok) {
-							log.error("failed to call method: " + param);
-							return;
-						}
-						log.debug("successful call of method: " + param);
+					public void run() {
+						path.getInstance().call(path, getParam(), arguments.toArray(), new StateFunctor() {
+							@Override
+							public void call(Exception e) {
+								Logging.log(log, "call procedure", path, e);
+							}
+						});
 					}
-				}));
-*/
+				});
 			}
 		});
@@ -63,3 +81,18 @@
 	}
 
+	@Override
+	public JPanel getPanel() {
+		return this;
+	}
+
+	@Override
+	public TreeNode getCurrentTreeNode() {
+		return owner.getCurrentTreeNode();
+	}
+
+	@Override
+	public ProcedureParam getParam() {
+		return (ProcedureParam) param;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 90)
@@ -26,4 +26,5 @@
 		super(valueParam);
 		textField = new JTextField();
+		textField.setName("value");
 
 		textField.setMinimumSize(new Dimension(0, Control.LINE_HEIGHT));
Index: /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 90)
@@ -78,4 +78,11 @@
 	}
 
+	/** This method is meant as a public interface to obtain current and correct value from control.
+	 *
+	 */
+	public final Object getCurrentValue() {
+		return filterValueThroughConstraints(pullValueFromUserInterface());
+	}
+
 	protected boolean notifyOfChange() {
 		if (!programmaticChange) {
@@ -83,5 +90,5 @@
 				return true;
 			}
-			return listener.onChange(filterValueThroughConstraints(pullValueFromUserInterface()));
+			return listener.onChange(getCurrentValue());
 		}
 		return true;
Index: /java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java	(revision 90)
@@ -97,4 +97,7 @@
 			return ImageProvider.NEURON_DEF_GROUP;
 		}
+		if (nodeName.equals("neuroconns") || path.endsWith("neuroconns")) {
+			return ImageProvider.NEURON_DEF_GROUP;
+		}
 		if (nodeName.equals("mechparts") || path.endsWith("mechparts")) {
 			return ImageProvider.MECH_PART_GROUP;
@@ -113,4 +116,7 @@
 		}
 		if (path.matches("^.*neurodefs/[0-9]+$")) {
+			return ImageProvider.NEURON_DEF;
+		}
+		if (path.matches("^.*neuroconns/[0-9]+$")) {
 			return ImageProvider.NEURON_DEF;
 		}
@@ -139,5 +145,5 @@
 			return ImageProvider.EVENT;
 		}
-		return ImageProvider.SERVER;
+		return ImageProvider.SIMULATOR;
 	}
 
Index: /java/main/src/main/java/com/framsticks/hosting/InstanceClient.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 90)
@@ -43,5 +43,5 @@
 	@Override
 	public void handle(final ApplicationRequest request, final ResponseCallback<?> responseCallback) {
-		instance.invokeLater(new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 90)
@@ -16,5 +16,5 @@
  * @author Piotr Sniegowski
  */
-public class ServerInstance extends LocalInstance implements JoinableParent {
+public abstract class ServerInstance extends LocalInstance implements JoinableParent {
 
 	private final static Logger log = Logger.getLogger(ServerInstance.class.getName());
@@ -23,11 +23,4 @@
 
 	public ServerInstance() {
-	}
-
-	@Override
-	protected void firstTask() {
-		super.firstTask();
-		assert hosted != null;
-		Dispatching.use(hosted, this);
 	}
 
@@ -53,5 +46,5 @@
 			return null;
 		}
-		FramsClass cached = registry.getInfoFromCache(id);
+		FramsClass cached = registry.getFramsClass(id);
 		if (cached != null) {
 			return cached;
@@ -67,5 +60,5 @@
 
 			registry.registerReflectedClass(null, id, nativeClass);
-			registry.putInfoIntoCache(framsClass);
+			registry.putFramsClass(framsClass);
 			return framsClass;
 		} catch (ClassNotFoundException ignored) {
@@ -98,15 +91,23 @@
 	public void childChangedState(Joinable joinable, JoinableState state) {
 		proceedToState(state);
+	}
 
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		assert hosted != null;
+		Dispatching.use(hosted, this);
 	}
 
 	@Override
 	protected void joinableInterrupt() {
+		super.joinableInterrupt();
 		Dispatching.drop(hosted, this);
 	}
 
 	@Override
-	protected void joinableFinish() {
-
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(hosted);
+		super.joinableJoin();
 	}
 
Index: /java/main/src/main/java/com/framsticks/model/BasePart.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BasePart.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/model/BasePart.java	(revision 90)
@@ -16,6 +16,6 @@
 	public void setPosition(Point3d p) { x = p.x; y = p.y; z = p.z; }
 
-	@ParamAnnotation(id = "m")
-	public double mass = 0.0;
+	@ParamAnnotation(id = "m", stringType = "f 0.1 999.0 1.0")
+	public double mass = 1.0;
 
 	@ParamAnnotation(id = "s")
Index: /java/main/src/main/java/com/framsticks/model/Creature.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Creature.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/model/Creature.java	(revision 90)
@@ -154,9 +154,9 @@
 	public final List<Joint> joints = new ArrayList<Joint>();
 	@ParamAnnotation
-	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
+	public final List<NeuroDefinition> neurodefs = new ArrayList<NeuroDefinition>();
 
 	public final List<Part> getParts() { return parts; }
 	public final List<Joint> getJoints() { return joints; }
-	public final List<NeuroDef> getNeuroDefs() { return neurodefs; }
+	public final List<NeuroDefinition> getNeuroDefs() { return neurodefs; }
 
 	@ParamAnnotation
Index: /java/main/src/main/java/com/framsticks/model/Joint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Joint.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/model/Joint.java	(revision 90)
@@ -10,5 +10,5 @@
  */
 @FramsClassAnnotation(id = "j")
-public class Joint extends BaseJoint {
+public class Joint extends BaseJoint implements ModelComponent {
 
 	@ParamAnnotation(id = "i")
Index: /java/main/src/main/java/com/framsticks/model/Model.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Model.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/model/Model.java	(revision 90)
@@ -3,12 +3,7 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Containers;
-import com.framsticks.util.lang.IterableIterator;
-import com.framsticks.util.math.Orientation;
-import org.apache.log4j.Logger;
 
 import java.util.ArrayList;
-import java.util.Iterator;
 import java.util.List;
 
@@ -17,7 +12,5 @@
  */
 @FramsClassAnnotation(id = "m")
-public class Model {
-
-	private final static Logger log = Logger.getLogger(Model.class);
+public class Model implements ModelComponent {
 
 	@ParamAnnotation(id = "se")
@@ -39,6 +32,9 @@
 	public final List<Joint> joints = new ArrayList<Joint>();
 
-	@ParamAnnotation
-	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
+	@ParamAnnotation(id = "neurodefs")
+	public final List<NeuroDefinition> neuroDefinitions = new ArrayList<NeuroDefinition>();
+
+	@ParamAnnotation(id = "neuroconns")
+	public final List<NeuroConnection> neuroConnections = new ArrayList<NeuroConnection>();
 
 	//TODO: why those methods returns and accepts doubles?
@@ -48,5 +44,5 @@
 	public double getNumjoints() { return (double)joints.size(); }
 	@ParamAnnotation
-	public double getNumneurons() { return (double)neurodefs.size(); }
+	public double getNumneurons() { return (double)neuroDefinitions.size(); }
 
 	//this is impossible to use, because numparts field is marked as readonly
@@ -56,49 +52,10 @@
 	public void setNumjoints(double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
 	@ParamAnnotation
-	public void setNumneurons(double numneurons) { Containers.resizeList(neurodefs, (int)(double)numneurons); }
+	public void setNumneurons(double numneurons) { Containers.resizeList(neuroDefinitions, (int)(double)numneurons); }
 
 	public List<Part> getParts() { return parts; }
 	public List<Joint> getJoints() { return joints; }
-	public List<NeuroDef> getNeuroDefs() { return neurodefs; }
+	public List<NeuroDefinition> getNeuroDefinitions() { return neuroDefinitions; }
+	public List<NeuroConnection> getNeuroConnections() { return neuroConnections; }
 
-	public static Model build(List<Object> objects) {
-		Iterator<Object> i = objects.iterator();
-		if (!i.hasNext()) {
-			return null;
-		}
-		Model f0Genotype = Casting.tryCast(Model.class, i.next());
-		if (f0Genotype == null) {
-			log.fatal("first object is not a Model");
-			return null;
-		}
-		for (Object object : new IterableIterator<Object>(i)) {
-			if (object instanceof Joint) {
-				f0Genotype.joints.add((Joint)object);
-				continue;
-			}
-			if (object instanceof Part) {
-				f0Genotype.parts.add((Part)object);
-				continue;
-			}
-			if (object instanceof NeuroDef) {
-				f0Genotype.neurodefs.add((NeuroDef) object);
-				continue;
-			}
-			log.error("invalid class: " + object.getClass().getCanonicalName());
-		}
-
-		for (Part p : f0Genotype.getParts()) {
-			p.setOrientation(new Orientation().rotate(p.getRotation()));
-		}
-		for (Joint j : f0Genotype.getJoints()) {
-			/** based on c++ Joint::attachToParts*/
-			Part p1 = f0Genotype.parts.get(j.part1);
-			Part p2 = f0Genotype.parts.get(j.part2);
-			assert p1 != null && p2 != null;
-			Orientation o = new Orientation().rotate(j.getRotation());
-			p2.setOrientation(p1.getOrientation().transform(o));
-			p2.setPosition(p2.getOrientation().transform(j.getDelta()).add(p1.getPosition()));
-		}
-		return f0Genotype;
-	}
 }
Index: /java/main/src/main/java/com/framsticks/model/ModelBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/ModelBuilder.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/model/ModelBuilder.java	(revision 90)
@@ -0,0 +1,121 @@
+package com.framsticks.model;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Iterator;
+import java.util.List;
+
+import com.framsticks.model.f0.Schema;
+import com.framsticks.params.Util;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+// import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.parsers.F0Parser;
+import com.framsticks.util.AutoBuilder;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.ResourceBuilder;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.IterableIterator;
+import com.framsticks.util.math.Orientation;
+
+@FramsClassAnnotation
+public class ModelBuilder extends ResourceBuilder<Model> implements AutoBuilder {
+
+	Schema schema;
+	final List<ModelComponent> components = new ArrayList<>();
+
+	@Override
+	public Model finish() {
+		if (stream == null && components.isEmpty()) {
+			throw new FramsticksException().msg("model builder instance not ready");
+		}
+		if (stream != null) {
+			if (schema == null) {
+				schema = Schema.getDefaultSchema();
+			}
+			F0Parser parser = new F0Parser(schema, stream);
+			components.addAll(Util.stripAccessInterface(parser.parse(), ModelComponent.class));
+		}
+		return build();
+	}
+
+	/**
+	 * @return the schema
+	 */
+	public Schema getSchema() {
+		return schema;
+	}
+
+	/**
+	 * @param schema the schema to set
+	 */
+	@AutoAppendAnnotation
+	public ModelBuilder schema(Schema schema) {
+		this.schema = schema;
+		return this;
+	}
+
+	@AutoAppendAnnotation
+	public ModelBuilder addComponent(ModelComponent component) {
+		components.add(component);
+		return this;
+	}
+
+	@AutoAppendAnnotation
+	public ModelBuilder addComponents(List<ModelComponent> component) {
+		this.components.addAll(component);
+		return this;
+	}
+
+	public Model build() {
+		Iterator<ModelComponent> i = components.iterator();
+		if (!i.hasNext()) {
+			throw new FramsticksException().msg("empty components list");
+		}
+		Model f0Genotype = Casting.tryCast(Model.class, i.next());
+		if (f0Genotype == null) {
+			throw new FramsticksException().msg("first component is not a Model");
+		}
+		for (ModelComponent component : new IterableIterator<ModelComponent>(i)) {
+			if (component instanceof Joint) {
+				f0Genotype.joints.add((Joint)component);
+				continue;
+			}
+			if (component instanceof Part) {
+				f0Genotype.parts.add((Part)component);
+				continue;
+			}
+			if (component instanceof NeuroDefinition) {
+				f0Genotype.neuroDefinitions.add((NeuroDefinition) component);
+				continue;
+			}
+			if (component instanceof NeuroConnection) {
+				f0Genotype.neuroConnections.add((NeuroConnection) component);
+				continue;
+			}
+			throw new FramsticksException().msg("invalid class").arg("class", component.getClass().getCanonicalName());
+		}
+
+		for (Part p : f0Genotype.getParts()) {
+			p.setOrientation(new Orientation().rotate(p.getRotation()));
+		}
+		for (Joint j : f0Genotype.getJoints()) {
+			/** based on c++ Joint::attachToParts*/
+			Part p1 = f0Genotype.parts.get(j.part1);
+			Part p2 = f0Genotype.parts.get(j.part2);
+			assert p1 != null && p2 != null;
+			Orientation o = new Orientation().rotate(j.getRotation());
+			p2.setOrientation(p1.getOrientation().transform(o));
+			p2.setPosition(p2.getOrientation().transform(j.getDelta()).add(p1.getPosition()));
+		}
+		return f0Genotype;
+	}
+
+	@Override
+	public List<Object> autoFinish() {
+		Model model = finish();
+		assert schema != null;
+		return Arrays.asList(schema.getRegistry(), model);
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/model/ModelComponent.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/ModelComponent.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/model/ModelComponent.java	(revision 90)
@@ -0,0 +1,5 @@
+package com.framsticks.model;
+
+public interface ModelComponent {
+
+}
Index: /java/main/src/main/java/com/framsticks/model/ModelPackage.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/ModelPackage.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/model/ModelPackage.java	(revision 90)
@@ -0,0 +1,27 @@
+package com.framsticks.model;
+
+import com.framsticks.params.ParamsPackage;
+import com.framsticks.params.Registry;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+@FramsClassAnnotation
+public class ModelPackage extends ParamsPackage {
+	@Override
+	public void register(Registry registry) {
+		register(registry, MechPart.class);
+		register(registry, MechPart.class);
+		register(registry, Joint.class);
+		register(registry, MechJoint.class);
+		register(registry, Neuro.class);
+		register(registry, NeuroDefinition.class);
+		register(registry, NeuroConnection.class);
+		register(registry, Part.class);
+		register(registry, Model.class);
+		register(registry, Creature.class);
+		register(registry, Genotype.class);
+		register(registry, World.class);
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/NeuroConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/NeuroConnection.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/model/NeuroConnection.java	(revision 90)
@@ -0,0 +1,27 @@
+package com.framsticks.model;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+/**
+ * The Class NeuroConnection.
+ */
+@FramsClassAnnotation(id = "c", name = "NeuroConn")
+public class NeuroConnection implements ModelComponent {
+
+	@ParamAnnotation(id = "n1")
+	public int thisNeuro;
+
+	@ParamAnnotation(id = "n2")
+	public int connectedNeuro;
+
+	@ParamAnnotation(id = "w")
+	public double weight;
+
+	@ParamAnnotation(id = "i")
+	public String info;
+
+	@ParamAnnotation(id = "Vstyle")
+	public String visualizationStyle;
+
+}
Index: /java/main/src/main/java/com/framsticks/model/NeuroDefinition.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/NeuroDefinition.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/model/NeuroDefinition.java	(revision 90)
@@ -0,0 +1,27 @@
+package com.framsticks.model;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@FramsClassAnnotation(id = "n", name = "NeuroDef")
+public class NeuroDefinition extends BaseNeuro implements ModelComponent {
+
+	@ParamAnnotation(id = "p")
+	public int part;
+
+	@ParamAnnotation(id = "j")
+	public int joint;
+
+	@ParamAnnotation(id = "d")
+	public String details;
+
+	@ParamAnnotation(id = "i")
+	public String info;
+
+	@ParamAnnotation(id = "Vstyle")
+	public String visualizationStyle;
+
+}
Index: /java/main/src/main/java/com/framsticks/model/Part.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Part.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/model/Part.java	(revision 90)
@@ -10,5 +10,5 @@
  */
 @FramsClassAnnotation(id = "p")
-public class Part extends BasePart {
+public class Part extends BasePart implements ModelComponent {
 
 	@ParamAnnotation
Index: /java/main/src/main/java/com/framsticks/model/f0/Schema.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/f0/Schema.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/model/f0/Schema.java	(revision 90)
@@ -7,9 +7,7 @@
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
-import com.framsticks.parsers.XmlLoader;
-import com.framsticks.util.DoubleMap;
-import com.framsticks.util.FramsticksException;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.lang.Casting;
 
-import com.framsticks.model.Package;
 
 /**
@@ -27,6 +25,8 @@
 
 	/** The neuro classes (classess representing different types of neurons). */
-	private DoubleMap<String, FramsClass> framsClasses = new DoubleMap<>();
-	private DoubleMap<String, NeuroClass> neuroClasses = new DoubleMap<>();
+	private final Registry framsClasses = new Registry();
+	private final Registry neuroClasses = new Registry();
+	// private DoubleMap<String, FramsClass> framsClasses = new DoubleMap<>();
+	// private DoubleMap<String, NeuroClass> neuroClasses = new DoubleMap<>();
 
 	public static InputStream getDefaultDefinitionAsStream() {
@@ -35,24 +35,11 @@
 	}
 
-	public static Schema load(InputStream stream) {
+	protected static Schema defaultSchema;
 
-		XmlLoader xmlLoader = new XmlLoader();
-		xmlLoader.setUseLowerCase(true);
-		xmlLoader.getRegistry()
-			.registerAndBuild(Schema.class)
-			.registerAndBuild(FramsClassBuilder.class)
-			.registerAndBuild(NeuroClassBuilder.class)
-			.registerAndBuild(ParamBuilder.class)
-			.registerAndBuild(NeuroParamBuilder.class)
-			.registerAndBuild(GroupBuilder.class)
-			;
-
-		Package.register(xmlLoader.getRegistry());
-
-		Object object = xmlLoader.load(Schema.getDefaultDefinitionAsStream());
-		if (!(object instanceof Schema)) {
-			throw new FramsticksException().msg("failed to load schema");
+	public synchronized static Schema getDefaultSchema() {
+		if (defaultSchema == null) {
+			defaultSchema = new SchemaBuilder().stream(getDefaultDefinitionAsStream()).finish();
 		}
-		return (Schema) object;
+		return defaultSchema;
 	}
 
@@ -60,11 +47,12 @@
 	}
 
+	@AutoAppendAnnotation
 	public void addClass(FramsClass framsClass) {
-		registry.putInfoIntoCache(framsClass);
+		registry.putFramsClass(framsClass);
 		if (framsClass instanceof NeuroClass) {
-			neuroClasses.put(framsClass.getId(), framsClass.getName(), (NeuroClass) framsClass);
+			neuroClasses.putFramsClass(framsClass);
 			return;
 		}
-		framsClasses.put(framsClass.getId(), framsClass.getName(), framsClass);
+		framsClasses.putFramsClass(framsClass);
 	}
 
@@ -74,23 +62,35 @@
 	}
 
-	public Set<NeuroClass> getNeuroClasses() {
-		return neuroClasses.getValues();
+	public Set<FramsClass> getNeuroClasses() {
+		return neuroClasses.getFramsClasses();
 	}
 
 	public Set<FramsClass> getFramsClasses() {
-		return framsClasses.getValues();
+		return framsClasses.getFramsClasses();
 	}
 
 	public NeuroClass getNeuroClass(String identifier) {
-		return neuroClasses.get(identifier);
+		return Casting.throwCast(NeuroClass.class, neuroClasses.getFramsClass(identifier));
 	}
 
 	public FramsClass getFramsClass(String identifier) {
-		return framsClasses.get(identifier);
+		return framsClasses.getFramsClass(identifier);
 	}
 
+	@ParamAnnotation
 	public final Registry getRegistry() {
 		return registry;
 	}
 
+	@ParamAnnotation
+	public final Registry getFramsRegistry() {
+		return framsClasses;
+	}
+
+	@ParamAnnotation
+	public final Registry getNeurosRegistry() {
+		return neuroClasses;
+	}
+
+
 }
